
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
/**
 * Die Zeichenfläche zur Darstellung des Graphen
 * 
 * @author Albert Wiedemann 
 * @version 1.0
 */
class Zeichenflaeche extends JComponent
{
    /** Feld aller zu zeichnenden Objekte. */
    private ArrayList<GraphenSymbol> alleSymbole;

    /**
     * Legt die Attribute an.
     */
    Zeichenflaeche ()
    {
        super();
        alleSymbole = new ArrayList<GraphenSymbol>();        
    }
    
    /**
     * Die eigentliche Zeichenmethode
     * @param g der Grafport zum Zeichnen
     */
    @Override public void paint (Graphics g)
    {
        g.setColor(new Color (230, 230, 230));
        g.fillRect(0, 0, getWidth() - 1, getHeight() - 1);
        synchronized (alleSymbole)
        {
            for (GraphenSymbol s: alleSymbole)
            {
                s.Zeichnen((Graphics2D) g);
            }
        }
    }
    
    /**
     * Trägt das angegebene Symbol in die Liste ein.
     * @param symbol das einzutragende Symbol
     */
    void Eintragen (GraphenSymbol symbol)
    {
        synchronized (alleSymbole)
        {
            alleSymbole.add(symbol);
        }
        repaint();
    }
    
    /**
     * Entfernt das angegebene Symbol.
     * @param symbol das zu entfernende Symbol
     */
    void Entfernen (GraphenSymbol symbol)
    {
        boolean res = false;
        synchronized (alleSymbole)
        {
            res = alleSymbole.remove(symbol);
        }
        repaint();
    }
}
